TYPO3 Version: 7
PHP Version:
Complexity:
Is Regression: No
Subject: Additional Identity Properties not set on mapping error
Description
Backport from #29290, see this issue for detailed problem description
When binding Fluid forms to nested objects, Fluid automatically adds
hidden fields with the identifiers of all affected objects so that
the persistence layer can update all objects correctly.
When a form was redisplayed due to property mapping errors, the
identity fields for the nested sub objects were no longer created.
This change fixes this by making sure all identity fields are rendered
recursively also after property mapping errors.
Example code to verify this::
<f:form action="update" object="{user}" objectName="user">
<f:form.textfield property="firstName" />
<f:for each="{user.invoices}" as="invoice" iteration="iteration"> {iteration.cycle}:
<f:form.textfield property="invoices.{iteration.index}.subject" />
</f:for>
<f:form.submit value="update" />
</f:form>

When submitting the form with validation errors, the redisplayed form
should contain a div with a hidden field named
"user[__identity]" for the user and one for each invoice.
Related issues:
related to TYPOS3.Fluid - Bug # 29290: Additional Identity Properties not set ... Resolved 2011-08-26

Associated revisions

Revision 622926a2 - 2014-11-03 18:59 - Anja Leichsenring
[BUGFIX] Additional Identity Properties not set on mapping error
When binding Fluid forms to nested objects, Fluid automatically adds
hidden fields with the identifiers of all affected objects so that

the persistence layer can update all objects correctly.

When a form was redisplayed due to property mapping errors, the
identity fields for the nested sub objects were no longer created.

This change fixes this by making sure all identity fields are rendered
recursively also after property mapping errors.

Backport from #29290

Resolves: #59253

Releases: master

Change-Id: Ib4b2a065d967e87aa42bdc889fef3f0b727b748b
Reviewed-on: http://review.typo3.org/30502

Reviewed-by: Stefan Froemken <froemken@gmail.com>

Tested-by: Stefan Froemken <froemken@gmail.com>

Reviewed-by: Markus Klein <klein.t3@reelworx.at>

Tested-by: Markus Klein <klein.t3@reelworx.at>

History

#1 - 2014-06-01 10:43 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30502

#2 - 2014-11-01 16:05 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/30502

#3 - 2014-11-01 16:37 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at http://review.typo3.org/30502

#4 - 2014-11-01 16:40 - Anja Leichsenring
- Description updated

#5 - 2014-11-01 16:40 - Anja Leichsenring
- TYPOS3 Version changed from 6.2 to 7

#6 - 2014-11-01 19:59 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.0rg/30502

#7 - 2014-11-01 20:28 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/30502
#8 - 2014-11-03 19:00 - Anja Leichsenring
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:622926a2442a9244a81b89b0e984638092a60bcf.
